package cn.com.qmth.stmms.biz.exam.bean;

import java.util.Date;
import java.util.List;

import cn.com.qmth.stmms.biz.exam.model.ExamStudent;
import cn.com.qmth.stmms.common.enums.SubjectiveStatus;
import io.swagger.annotations.ApiModelProperty;

public class ScoreVo {

    @ApiModelProperty("科目")
    private String subjectText;

    /**
     * 学号
     */
    @ApiModelProperty("学号")
    private String studentCode;

    private Integer id;

    /**
     * 考试ID
     */
    private Integer examId;

    /**
     * 学校ID
     */
    private Integer schoolId;

    /**
     * 学习中心
     */
    private String campusName;

    /**
     * 科目代码
     */
    private String subjectCode;

    /**
     * 科目名称
     */
    private String subjectName;

    /**
     * 试卷类型
     */
    private String paperType;

    /**
     * 准考证号
     */
    @ApiModelProperty("准考证号")
    private String examNumber;

    /**
     * 密号
     */
    private String secretNumber;

    /**
     * 姓名
     */
    @ApiModelProperty("姓名")
    private String name;

    /**
     * 试卷袋签到表编号
     */
    private String packageCode;

    /**
     * 考生考点信息
     */
    @ApiModelProperty("考点")
    private String examSite;

    /**
     * 考生考场信息
     */
    @ApiModelProperty("考场")
    private String examRoom;

    /**
     * 考生备注信息
     */
    private String remark;

    /**
     * 扫描批次编号
     */
    private String batchCode;

    /**
     * 客观题图数量
     */
    private Integer objectivePageCount;

    /**
     * 原图数量
     */
    private Integer sheetCount;

    /**
     * 裁切图数量
     */
    private Integer sliceCount;

    /**
     * 客观答案
     */
    private String answers;

    /**
     * 是否已上传
     */
    private Boolean upload;

    /**
     * 是否缺考
     */
    private Boolean absent;

    /**
     * 是否人工指定缺考
     */
    private Boolean manualAbsent;

    private Boolean breach;

    /**
     * 是否数据校验异常
     */
    private Boolean exception;

    /**
     * 是否数试评
     */
    private Boolean trial;

    /**
     * 上传时间
     */
    private Date uploadTime;

    /**
     * 客观总分
     */
    private Double objectiveScore;

    @ApiModelProperty("客观总分")
    private String objectiveScoreText;

    /**
     * 客观题得分明细
     */
    private String objectiveScoreList;

    /**
     * 主观题状态
     */
    private SubjectiveStatus subjectiveStatus;

    /**
     * 主观总分
     */
    private Double subjectiveScore;

    @ApiModelProperty("主观总分")
    private String subjectiveScoreText;

    /**
     * 主观题得分明细
     */
    private String subjectiveScoreList;

    /**
     * 科目层次信息
     */
    @ApiModelProperty("层次")
    private String subjectLevel;

    /**
     * 专业类型信息
     */
    @ApiModelProperty("专业类型")
    private String subjectCategory;

    @ApiModelProperty("全卷总分")
    private String totalScoreText;

    /**
     * 学院
     */
    @ApiModelProperty("学院")
    private String college;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String className;

    /**
     * 任课老师
     */
    @ApiModelProperty("任课老师")
    private String teacher;

    private List<String> sheetUrls;

    private List<String> packageUrls;

    private String answerUrl;

    private String examName;

    @ApiModelProperty("是否缺考")
    private String absentText;

    @ApiModelProperty("是否上传")
    private String uploadText;

    @ApiModelProperty("是否违纪")
    private String breachText;

    public String getSubjectText() {
        return subjectText;
    }

    public void setSubjectText(String subjectText) {
        this.subjectText = subjectText;
    }

    public String getStudentCode() {
        return studentCode;
    }

    public void setStudentCode(String studentCode) {
        this.studentCode = studentCode;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public Integer getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Integer schoolId) {
        this.schoolId = schoolId;
    }

    public String getCampusName() {
        return campusName;
    }

    public void setCampusName(String campusName) {
        this.campusName = campusName;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getPaperType() {
        return paperType;
    }

    public void setPaperType(String paperType) {
        this.paperType = paperType;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getSecretNumber() {
        return secretNumber;
    }

    public void setSecretNumber(String secretNumber) {
        this.secretNumber = secretNumber;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPackageCode() {
        return packageCode;
    }

    public void setPackageCode(String packageCode) {
        this.packageCode = packageCode;
    }

    public String getExamSite() {
        return examSite;
    }

    public void setExamSite(String examSite) {
        this.examSite = examSite;
    }

    public String getExamRoom() {
        return examRoom;
    }

    public void setExamRoom(String examRoom) {
        this.examRoom = examRoom;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getBatchCode() {
        return batchCode;
    }

    public void setBatchCode(String batchCode) {
        this.batchCode = batchCode;
    }

    public Integer getObjectivePageCount() {
        return objectivePageCount;
    }

    public void setObjectivePageCount(Integer objectivePageCount) {
        this.objectivePageCount = objectivePageCount;
    }

    public Integer getSheetCount() {
        return sheetCount;
    }

    public void setSheetCount(Integer sheetCount) {
        this.sheetCount = sheetCount;
    }

    public Integer getSliceCount() {
        return sliceCount;
    }

    public void setSliceCount(Integer sliceCount) {
        this.sliceCount = sliceCount;
    }

    public String getAnswers() {
        return answers;
    }

    public void setAnswers(String answers) {
        this.answers = answers;
    }

    public Boolean getUpload() {
        return upload;
    }

    public void setUpload(Boolean upload) {
        this.upload = upload;
    }

    public Boolean getAbsent() {
        return absent;
    }

    public void setAbsent(Boolean absent) {
        this.absent = absent;
    }

    public Boolean getManualAbsent() {
        return manualAbsent;
    }

    public void setManualAbsent(Boolean manualAbsent) {
        this.manualAbsent = manualAbsent;
    }

    public Boolean getBreach() {
        return breach;
    }

    public void setBreach(Boolean breach) {
        this.breach = breach;
    }

    public Boolean getException() {
        return exception;
    }

    public void setException(Boolean exception) {
        this.exception = exception;
    }

    public Boolean getTrial() {
        return trial;
    }

    public void setTrial(Boolean trial) {
        this.trial = trial;
    }

    public Date getUploadTime() {
        return uploadTime;
    }

    public void setUploadTime(Date uploadTime) {
        this.uploadTime = uploadTime;
    }

    public Double getObjectiveScore() {
        return objectiveScore;
    }

    public void setObjectiveScore(Double objectiveScore) {
        this.objectiveScore = objectiveScore;
    }

    public String getObjectiveScoreText() {
        return objectiveScoreText;
    }

    public void setObjectiveScoreText(String objectiveScoreText) {
        this.objectiveScoreText = objectiveScoreText;
    }

    public String getObjectiveScoreList() {
        return objectiveScoreList;
    }

    public void setObjectiveScoreList(String objectiveScoreList) {
        this.objectiveScoreList = objectiveScoreList;
    }

    public SubjectiveStatus getSubjectiveStatus() {
        return subjectiveStatus;
    }

    public void setSubjectiveStatus(SubjectiveStatus subjectiveStatus) {
        this.subjectiveStatus = subjectiveStatus;
    }

    public Double getSubjectiveScore() {
        return subjectiveScore;
    }

    public void setSubjectiveScore(Double subjectiveScore) {
        this.subjectiveScore = subjectiveScore;
    }

    public String getSubjectiveScoreText() {
        return subjectiveScoreText;
    }

    public void setSubjectiveScoreText(String subjectiveScoreText) {
        this.subjectiveScoreText = subjectiveScoreText;
    }

    public String getSubjectiveScoreList() {
        return subjectiveScoreList;
    }

    public void setSubjectiveScoreList(String subjectiveScoreList) {
        this.subjectiveScoreList = subjectiveScoreList;
    }

    public String getSubjectLevel() {
        return subjectLevel;
    }

    public void setSubjectLevel(String subjectLevel) {
        this.subjectLevel = subjectLevel;
    }

    public String getSubjectCategory() {
        return subjectCategory;
    }

    public void setSubjectCategory(String subjectCategory) {
        this.subjectCategory = subjectCategory;
    }

    public String getTotalScoreText() {
        return totalScoreText;
    }

    public void setTotalScoreText(String totalScoreText) {
        this.totalScoreText = totalScoreText;
    }

    public String getCollege() {
        return college;
    }

    public void setCollege(String college) {
        this.college = college;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getTeacher() {
        return teacher;
    }

    public void setTeacher(String teacher) {
        this.teacher = teacher;
    }

    public List<String> getSheetUrls() {
        return sheetUrls;
    }

    public void setSheetUrls(List<String> sheetUrls) {
        this.sheetUrls = sheetUrls;
    }

    public List<String> getPackageUrls() {
        return packageUrls;
    }

    public void setPackageUrls(List<String> packageUrls) {
        this.packageUrls = packageUrls;
    }

    public String getAnswerUrl() {
        return answerUrl;
    }

    public void setAnswerUrl(String answerUrl) {
        this.answerUrl = answerUrl;
    }

    public String getExamName() {
        return examName;
    }

    public void setExamName(String examName) {
        this.examName = examName;
    }

    public String getAbsentText() {
        return absentText;
    }

    public void setAbsentText(String absentText) {
        this.absentText = absentText;
    }

    public String getUploadText() {
        return uploadText;
    }

    public void setUploadText(String uploadText) {
        this.uploadText = uploadText;
    }

    public String getBreachText() {
        return breachText;
    }

    public void setBreachText(String breachText) {
        this.breachText = breachText;
    }

    public static ScoreVo of(ExamStudent from) {
        if (from == null) {
            return null;
        }
        ScoreVo ret = new ScoreVo();
        ret.setSubjectText(from.getSubjectCode() + "-" + from.getSubjectName() + " " + from.getSubjectRemark());
        ret.setStudentCode(from.getStudentCode());
        ret.setId(from.getId());
        ret.setExamId(from.getExamId());
        ret.setSchoolId(from.getSchoolId());
        ret.setCampusName(from.getCampusName());
        ret.setSubjectCode(from.getSubjectCode());
        ret.setSubjectName(from.getSubjectName());
        ret.setPaperType(from.getPaperType());
        ret.setExamNumber(from.getExamNumber());
        ret.setSecretNumber(from.getSecretNumber());
        ret.setName(from.getName());
        ret.setPackageCode(from.getPackageCode());
        ret.setExamSite(from.getExamSite());
        ret.setExamRoom(from.getExamRoom());
        ret.setRemark(from.getRemark());
        ret.setBatchCode(from.getBatchCode());
        ret.setObjectivePageCount(from.getObjectivePageCount());
        ret.setSheetCount(from.getSheetCount());
        ret.setSliceCount(from.getSliceCount());
        ret.setAnswers(from.getAnswers());
        ret.setUpload(from.isUpload());
        ret.setAbsent(from.isAbsent());
        ret.setManualAbsent(from.isManualAbsent());
        ret.setBreach(from.isBreach());
        ret.setException(from.isException());
        ret.setTrial(from.isTrial());
        ret.setUploadTime(from.getUploadTime());
        ret.setObjectiveScore(from.getObjectiveScore());
        ret.setObjectiveScoreList(from.getObjectiveScoreList());
        ret.setSubjectiveStatus(from.getSubjectiveStatus());
        ret.setSubjectiveScore(from.getSubjectiveScore());
        ret.setSubjectiveScoreList(from.getSubjectiveScoreList());
        ret.setSubjectLevel(from.getSubjectLevel());
        ret.setSubjectCategory(from.getSubjectCategory());
        ret.setCollege(from.getCollege());
        ret.setClassName(from.getClassName());
        ret.setTeacher(from.getTeacher());
        ret.setSheetUrls(from.getSheetUrls());
        ret.setPackageUrls(from.getPackageUrls());
        ret.setAnswerUrl(from.getAnswerUrl());
        ret.setExamName(from.getExamName());

        if (from.isAbsent() == true || from.isUpload() == false) {
            ret.setObjectiveScoreText("-");
            ret.setSubjectiveScoreText("-");
            ret.setTotalScoreText("-");
            ret.setAbsentText("缺考");
        } else if (from.isBreach() == true) {
            ret.setObjectiveScoreText("0");
            ret.setSubjectiveScoreText("0");
            ret.setTotalScoreText("0");
        } else {
            ret.setObjectiveScoreText(from.getObjectiveScoreString());
            ret.setSubjectiveScoreText(from.getSubjectiveScoreString());
            ret.setTotalScoreText(from.getTotalScoreString());
        }

        if (from.isUpload() == false) {
            ret.setUploadText("未上传");
        } else {
            ret.setUploadText("已上传");
        }
        if (from.isBreach() == true) {
            ret.setBreachText("违纪");
        }
        return ret;
    }
}
