package cn.com.qmth.stmms.biz.exam.bean;

import java.util.Date;

import cn.com.qmth.stmms.biz.config.model.SystemConfig;
import cn.com.qmth.stmms.common.enums.ConfigType;
import io.swagger.annotations.ApiModelProperty;

public class SystemConfigVo {

    private Integer id;

    private ConfigType type;

    @ApiModelProperty(value = "类型")
    private String name;

    private String description;

    @ApiModelProperty(value = "详情")
    private String descriptionText;

    private Date updateTime;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public ConfigType getType() {
        return type;
    }

    public void setType(ConfigType type) {
        this.type = type;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescriptionText() {
        return descriptionText;
    }

    public void setDescriptionText(String descriptionText) {
        this.descriptionText = descriptionText;
    }

    public static SystemConfigVo of(SystemConfig from) {
        if (from == null) {
            return null;
        }
        SystemConfigVo ret = new SystemConfigVo();
        ret.setId(from.getId());
        ret.setType(from.getType());
        ret.setDescription(from.getDescription());
        ret.setUpdateTime(from.getUpdateTime());
        ret.setName(from.getType().getName());
        if (ConfigType.AUTO_REPORT.equals(from.getType()) || ConfigType.STUDENT_SHEET_COUNT.equals(from.getType())) {
            if ("on".equals(from.getDescription())) {
                ret.setDescriptionText("开启");
            } else {
                ret.setDescriptionText("关闭");
            }
        } else {
            ret.setDescriptionText(from.getDescription());
        }
        return ret;
    }
}
